#!/usr/bin/perl -T -w
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# (c) Nico Leidecker, 2007
# <mailto:nico@nth-dimension.org.uk>
# <http://www.nth-dimension.org.uk/> / <http://www.leidecker.info/>

use strict;
use Fuzzled::Protocol::NNTP;

my $hostname;
my $portnumber;
my $username;
my $password;
my $maximumprocess;
my $debugflag;
my $nntphandle;

sub usage {
	die("usage: " . $0 . " <hostname> <portnumber> <maximumprocess> <debugflag>");
}


if (@ARGV != 4) {
	usage();
}
$hostname = shift;
$portnumber = shift;
$maximumprocess = shift;
$debugflag = shift;

if ($hostname =~ /([A-z0-9-.]+)/) {
	$hostname = $1;
} else {
	usage();
}

if ($portnumber =~ /([0-9]+)/) {
	$portnumber = $1;
} else {
	usage();
}

if ($maximumprocess =~ /([0-9]+)/) {
	$maximumprocess = $1;
} else {
	usage();
}

if ($debugflag =~ /([01])/) {
	$debugflag = $1;
} else {
	usage();
}

$nntphandle = Fuzzled::Protocol::NNTP->new($hostname, $portnumber, $maximumprocess, $debugflag);
$nntphandle->attack();
exit(1);
