# $Header: /var/lib/cvsd/var/lib/cvsd/Fuzzled/src/Fuzzled-Protocol-CAArcServe6050/lib/Fuzzled/Protocol/CAArcServe6050.pm,v 1.3 2007-09-15 22:42:26 timb Exp $
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA
#
# (c) Tim Brown, 2006
# <mailto:timb@nth-dimension.org.uk>
# <http://www.nth-dimension.org.uk/> / <http://www.machine.org.uk/>

package Fuzzled::Protocol::CAArcServe6050;

use 5.008007;
use strict;
use warnings;

require Exporter;
use AutoLoader qw(AUTOLOAD);

use Fuzzled::Helper::SharedMemory;
use Fuzzled::Helper;
use Fuzzled::Helper::TCP;
use Fuzzled::Factory::Increment;

our @ISA = qw(Exporter);

# Items to export into callers namespace by default. Note: do not export
# names by default without a very good reason. Use EXPORT_OK instead.
# Do not simply export all your public functions/methods/constants.

# This allows declaration use Fuzzled::Protocol::CAArcServe6050 ':all';
# If you do not need this, moving things directly into @EXPORT or @EXPORT_OK
# will save memory.
our %EXPORT_TAGS = ( 'all' => [ qw(
	
) ] );

our @EXPORT_OK = ( @{ $EXPORT_TAGS{'all'} } );

our @EXPORT = qw(
	
);

our $VERSION = ('$Header: /var/lib/cvsd/var/lib/cvsd/Fuzzled/src/Fuzzled-Protocol-CAArcServe6050/lib/Fuzzled/Protocol/CAArcServe6050.pm,v 1.3 2007-09-15 22:42:26 timb Exp $' =~ m/.Header: .* ([\d.]+) .*/)[0];

# Preloaded methods go here.
sub new {
	my $self;
	$self = shift;
	$self = bless({}, $self);
	$self->{'hostname'} = shift;
	$self->{'maximumprocess'} = shift;
	$self->{'debugflag'} = shift;
	$self->{'debugflag'} && print STDERR "Fuzzled::Protocol::CAArcServe6050->new() succeeded\r\n";
	return $self;
}


sub attack {
	my $self;
	my $tcphandle;
	my $currentprocess;
	my $memoryerror;
	my $consumererror;
	my $processid;
	$self = shift;
	$self->{'helperhandle'} = Fuzzled::Helper->new($self->{'debugflag'});
	$tcphandle = Fuzzled::Helper::TCP->new($self->{'hostname'}, 6050, $self->{'debugflag'});
	if (!$tcphandle) {
		die "Fuzzled::Helper::TCP->new() failed: unable to connect to host " . $self->{'hostname'} . ", port 6050\r\n";
	}
	$tcphandle->close();
	$currentprocess = 0;
	$memoryerror = 0;
	$consumererror = 0;
	while (($currentprocess < $self->{'maximumprocess'}) && ($memoryerror == 0) && ($consumererror == 0)) {
		$self->{'memoryhandle'} = Fuzzled::Helper::SharedMemory->new(20, "\x03EOD\x04", $self->{'debugflag'});
		if (!$self->{'memoryhandle'}) {
			$memoryerror = 1;
		} else {
			$self->{'memoryhandle'}->write("\x03EMPTY\x04");
			$processid = $self->consumer();
			if ($processid < 0) {
				$self->{'memoryhandle'}->dealloc();
				$consumererror = 1;
			} else {
				if ($processid == 0) {
					print "[fuzzled] " . $$ . " finished\r\n";
					$self->{'memoryhandle'}->dealloc();
					$self->{'debugflag'} && print STDERR "Fuzzled::Protocol::CAArcServe6050->attack() succeeded: consumer\r\n";
					return 2;
				}
				#print "[fuzzled] " . $$ . " begat " . $processid . "\r\n";
				$self->{'memoryhandles'}[$currentprocess] = $self->{'memoryhandle'};
				$currentprocess ++;
			}
		}
	}
	$self->{'maximumprocess'} = $currentprocess;
	if ($self->{'maximumprocess'} > 0) {
		if ($self->producer() > 0) {
			$self->{'debugflag'} && print STDERR "Fuzzled::Protocol::CAArcServe6050->attack() succeeded: producer\r\n";
			return 1;
		}
		$self->{'debugflag'} && print STDERR "Fuzzled::Protocol::CAArcServe6050->attack() failed: producer\r\n";
		return 0;
	}
	$self->{'debugflag'} && print STDERR "Fuzzled::Protocol::CAArcServe6050->attack() failed: producer\r\n";
	return 0;
}

sub producer {
	my $self;
	my $commandcode1handle;
	my $commandcode1string;
	my $commandcode2handle;
	my $commandcode2string;
	my $requeststring;
	my $queuedflag;
	my $memoryhandle;
	$self = shift;
	$SIG{'INT'} = sub {
		$queuedflag = 1;
		while ($queuedflag == 1) {
			$queuedflag = 0;
			foreach $memoryhandle (@{$self->{'memoryhandles'}}) {
				if ($memoryhandle->lock() == 1) {
					if ($memoryhandle->peek() eq "\x03EMPTY\x04") {
						$memoryhandle->poke("\x03END\x04");
						$queuedflag = 1;
					} else {
						if ($memoryhandle->peek() ne "\x03END\x04") {
							$queuedflag = 1;
						}
					}
					$memoryhandle->unlock();
				}		
			}
		}
		die "Fuzzled::Protocol::CAArcServe6050->producer() failed: interrupted\r\n";
	};
	print "[fuzzled] brute forcing command codes\r\n";
	$commandcode1handle = Fuzzled::Factory::Increment->new(0, 255, 1);
	while ($commandcode1string = $commandcode1handle->generate()) {
		$commandcode2handle = Fuzzled::Factory::Increment->new(0, 255, 1);
		while ($commandcode2string = $commandcode2handle->generate()) {
			$queuedflag = 0;
			while ($queuedflag != 1) {
				foreach $memoryhandle (@{$self->{'memoryhandles'}}) {
					if ($memoryhandle->lock() == 1) {
						if ($memoryhandle->peek() eq "\x03EMPTY\x04") {
							$memoryhandle->poke(pack("CC", $commandcode1string, $commandcode2string));
							$memoryhandle->unlock();
							$queuedflag = 1;
							last;
						}
						$memoryhandle->unlock();
					}
				}
				if ($queuedflag == 0) {
					$self->{'helperhandle'}->sleep(0.1);
				}
			}
		}
	}
	$queuedflag = 1;
	while ($queuedflag == 1) {
		$queuedflag = 0;
		foreach $memoryhandle (@{$self->{'memoryhandles'}}) {
			if ($memoryhandle->lock() == 1) {
				if ($memoryhandle->peek() eq "\x03EMPTY\x04") {
					$memoryhandle->poke("\x03END\x04");
					$queuedflag = 1;
				} else {
					if ($memoryhandle->peek() ne "\x03END\x04") {
						$queuedflag = 1;
					}
				}
				$memoryhandle->unlock();
			}
			
		}
	}
	$self->{'debugflag'} && print STDERR "Fuzzled::Protocol::CAArcServe6050->producer() succeeded\r\n";
	return 1;
}

sub consumer {
	my $self;
	my $processid;
	my $requeststring;
	my $fullrequeststring;
	my $tcphandle;
	my $responsestring;
	$self = shift;
	$processid = fork();
	if ($processid == 0) {
		$SIG{'INT'} = sub {
			$self->{'debugflag'} && print STDERR "Fuzzled::Protocol::CAArcServe6050->consumer() interrupted\r\n";
		};
		while ($self->{'memoryhandle'}->read() ne "\x03END\x04") {
			if ($self->{'memoryhandle'}->lock() == 1) {
				$requeststring = $self->{'memoryhandle'}->peek();
				if ($requeststring eq "\x03END\x04") {
					$self->{'memoryhandle'}->unlock();
				} else {
					if ($requeststring eq "\x03EMPTY\x04") {
						$self->{'memoryhandle'}->unlock();
						$self->{'helperhandle'}->sleep(1);
					} else {
						$tcphandle = Fuzzled::Helper::TCP->new($self->{'hostname'}, 6050, $self->{'debugflag'});
						if (!$tcphandle) {
							die "Fuzzled::Helper::TCP->new() failed: unable to connect to host " . $self->{'hostname'} . ", port 6050\r\n";
						}
						$self->{'memoryhandle'}->poke("\x03EMPTY\x04");
						$self->{'memoryhandle'}->unlock();
						$fullrequeststring = $requeststring . "\r\n";
						$fullrequeststring = $fullrequeststring . "\r\n";
						$fullrequeststring = $fullrequeststring . "\r\n";
						$tcphandle->write($fullrequeststring);
						print "[fuzzled] " . $fullrequeststring . "\n";
						$self->{'helperhandle'}->parsepacket($fullrequeststring, "\x00");
						$self->{'helperhandle'}->log("CAArcServe6050." . $$, "wrote " . $fullrequeststring . "\r\n");
						do {
							$responsestring = $tcphandle->read();
							print "[fuzzled] " . $responsestring . "\n";
							$self->{'helperhandle'}->parsepacket($responsestring, "\x00");
							$self->{'helperhandle'}->log("CAArcServe6050." . $$, "read " . $responsestring . "\r\n");
						} while ($responsestring ne "");
						$tcphandle->close();
					}
				}
				
			} else {
				$self->{'helperhandle'}->sleep(1);
			}
		}
	}
	$self->{'debugflag'} && print STDERR "Fuzzled::Protocol::CAArcServe6050->consumer() succeeded\r\n";
	return $processid;
}

# Autoload methods go after =cut, and are processed by the autosplit program.

1;
__END__

=head1 NAME

Perl extension for Fuzzled to fuzz CA ArcServe port 6050 

=head1 SYNOPSIS

  use Fuzzled::Protocol::CAArcServe6050;

  my $caarcserve6050testhandle;

  $caarcserve6050testhandle = Fuzzled::Protocol::CAArcServe6050->new("service.example.org", 10, 1);
  $caarcserve6050testhandle->attack();

=head1 DESCRIPTION

C<Fuzzled::Protocol::CAArcServe6050> is a Perl extension for Fuzzled to fuzz CA ArcServe port 6050.  The following methods are available:

=over 4

=item Fuzzled::Protocol::CAArcServe6050->new(<hostname>, <maxiumumprocess>, <debugflag>)

Constructs a new C<Fuzzled::Protocol::CAArcServe6050> object describing the connection to be fuzzed.

=item Fuzzled::Protocol::CAArcServe6050->attack()

Carries out the fuzzing.

Returns 1 

=head1 SEE ALSO

=head1 AUTHOR

(c) Tim Brown, 2006
<mailto:timb@nth-dimension.org.uk>

=head1 COPYRIGHT AND LICENSE

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2 of the License, or
(at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301  USA

=cut
